<template>
	<nav :class="sidebarState ? 'is-active' : ''">
		<ul v-for="(menu, index) in menus" :key="index">
			<li
				v-if="menu.url == endpoint && menu.url !== '/plugins'"
				class="highlighted rounded"
			>
				<NuxtLink :to="menu.url"
					><div class="text-sidebar">{{ menu.title }}</div></NuxtLink
				>
			</li>
			<li
				v-else-if="menu.url === '/plugins'"
				@click="pluginsToggle"
				class="cursor-pointer"
			>
				{{ menu.title }}
				<i
					:class="
						isPluginClicked
							? 'bzi-caret-up plugins-icon'
							: 'bzi-caret-down plugins-icon'
					"
				></i>
				<NuxtLink
					class="ml-24 mt-16 dropdown-link cursor-pointer"
					v-show="isPluginClicked"
					v-for="(dropdown, index) in menu.dropdown"
					:key="index"
					:to="dropdown.url"
					><div class="text-sidebar">{{ dropdown.title }}</div></NuxtLink
				>
			</li>
			<li v-else>
				<NuxtLink :to="menu.url"
					><div class="text-sidebar">{{ menu.title }}</div></NuxtLink
				>
			</li>
		</ul>
	</nav>
</template>

<script>
import menuList from '../static/json/menus.json'
export default {
	data() {
		return {
			menus: menuList.data,
			endpoint: this.$route.path,
			isPluginClicked: false
		}
	},
	props: {
		sidebarState: {
			type: Boolean,
			required: true
		}
	},
	watch: {
		$route() {
			this.endpoint = this.$route.path
		}
	},
	methods: {
		pluginsToggle() {
			this.isPluginClicked = !this.isPluginClicked
		}
	}
}
</script>

<style lang="scss" scoped>
nav {
	width: 220px;
	top: 56px;
	left: 0;
	bottom: 0;
	position: fixed;
	overflow-y: auto;
	overflow-x: hidden;
	background-color: #fff;
	z-index: 100;
	transition: transform 0.3s ease-in-out;
	transform: translateX(-100%);

	@media #{$medium} {
		transform: translateX(0);
	}

	&.is-active {
		transform: translateX(0);
	}
}

.dropdown-link {
	display: block;
}

.cursor-pointer {
	cursor: pointer;
}

/* width */
body::-webkit-scrollbar {
	width: 5px;
}

/* Track */
::-webkit-scrollbar-track {
	background: transparent;
}

/* Handle */
::-webkit-scrollbar-thumb {
	background: #888;
	border-radius: 2px;
}

/* Handle on hover */
::-webkit-scrollbar-thumb:hover {
	background: #555;
}

ul {
	list-style-type: none;
	padding: 0;
	margin: 0;
}

.plugins-icon {
	float: right;
}

li {
	padding: 8px 8px 8px 24px;
	color: $text;
	font-size: 0.93rem;
}

ul:first-child {
	margin-top: 5px;
}

ul:last-child {
	padding-bottom: 20px;
}

li:hover {
	color: #0b0b0b;
}

.highlighted {
	background-color: #e6e6e6;
	color: #0b0b0b;
}

.text-sidebar {
	width: 100%;
	color: #4d4d4d;
}
</style>
